%if 0%{?fedora}
%global with_devel 1
%global with_bundled 0
%global with_debug 1
%else
%global with_devel 0
%global with_bundled 1
%global with_debug 0
%endif

%if 0%{?with_debug}
# https://bugzilla.redhat.com/show_bug.cgi?id=995136#c12
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif
%global provider        github
%global provider_tld    com
%global project         mongodb
%global repo            mongo-tools
# https://github.com/mongodb/mongo-tools
%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}
%global commit          efe71bf185cdcfe9632f1fc2e42ca4e895f93269
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

# Git hash in https://github.com/mongodb/mongo which corresponds to Version
%global mongohash 6201872043ecbbc0a4cc169b5482dcf385fc464f

Name:		%{repo}
Version:        3.0.4
Release:        0.1.git%{shortcommit}%{?dist}
Summary:        MongoDB Tools
License:        ASL 2.0
URL:            https://%{import_path}
Source0:	https://%{import_path}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
# Mongo-tools does not contain man files yet
# - see https://groups.google.com/forum/#!topic/mongodb-dev/t6Sd2Bki12I
Source1:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/bsondump.1
Source2:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongodump.1
Source3:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongoexport.1
Source4:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongofiles.1
Source5:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongoimport.1
Source6:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongooplog.1
Source7:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongorestore.1
Source8:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongostat.1
Source9:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongotop.1
Source10:       https://github.com/mongodb/mongo/raw/%{mongohash}/APACHE-2.0.txt

%if ! 0%{?with_bundled}
Patch0:         change-import-path.patch
BuildRequires:  golang >= 1.2.1-3
BuildRequires:  golang(github.com/howeyc/gopass)
BuildRequires:  golang(github.com/jessevdk/go-flags)
BuildRequires:  golang(github.com/smartystreets/goconvey/convey)
BuildRequires:  golang(github.com/10gen/openssl)
BuildRequires:  golang(golang.org/x/crypto/ssh/terminal)
BuildRequires:  golang(gopkg.in/mgo.v2)
BuildRequires:  golang(gopkg.in/mgo.v2/bson)
BuildRequires:  golang(gopkg.in/tomb.v2)
%endif

Conflicts:      mongodb < 3.0.0

ExclusiveArch:  x86_64

%description
The MongoDB tools provides import, export, and diagnostic capabilities.

%if 0%{?with_devel}
%package devel
Summary:       %{summary}

BuildRequires: golang >= 1.2.1-3
BuildRequires: golang(github.com/howeyc/gopass)
BuildRequires: golang(github.com/jessevdk/go-flags)
BuildRequires: golang(github.com/smartystreets/goconvey/convey)
BuildRequires: golang(github.com/10gen/openssl)
BuildRequires: golang(golang.org/x/crypto/ssh/terminal)
BuildRequires: golang(gopkg.in/mgo.v2)
BuildRequires: golang(gopkg.in/mgo.v2/bson)
BuildRequires: golang(gopkg.in/tomb.v2)

Requires:      golang(github.com/howeyc/gopass)
Requires:      golang(github.com/jessevdk/go-flags)
Requires:      golang(github.com/smartystreets/goconvey/convey)
Requires:      golang(github.com/10gen/openssl)
Requires:      golang(golang.org/x/crypto/ssh/terminal)
Requires:      golang(gopkg.in/mgo.v2)
Requires:      golang(gopkg.in/mgo.v2/bson)
Requires:      golang(gopkg.in/tomb.v2)

Provides:      golang(%{import_path}/bsondump) = %{version}-%{release}
Provides:      golang(%{import_path}/common) = %{version}-%{release}
Provides:      golang(%{import_path}/common/archive) = %{version}-%{release}
Provides:      golang(%{import_path}/common/auth) = %{version}-%{release}
Provides:      golang(%{import_path}/common/bsonutil) = %{version}-%{release}
Provides:      golang(%{import_path}/common/db) = %{version}-%{release}
Provides:      golang(%{import_path}/common/db/kerberos) = %{version}-%{release}
Provides:      golang(%{import_path}/common/db/openssl) = %{version}-%{release}
Provides:      golang(%{import_path}/common/intents) = %{version}-%{release}
Provides:      golang(%{import_path}/common/json) = %{version}-%{release}
Provides:      golang(%{import_path}/common/log) = %{version}-%{release}
Provides:      golang(%{import_path}/common/options) = %{version}-%{release}
Provides:      golang(%{import_path}/common/password) = %{version}-%{release}
Provides:      golang(%{import_path}/common/progress) = %{version}-%{release}
Provides:      golang(%{import_path}/common/signals) = %{version}-%{release}
Provides:      golang(%{import_path}/common/testutil) = %{version}-%{release}
Provides:      golang(%{import_path}/common/text) = %{version}-%{release}
Provides:      golang(%{import_path}/common/util) = %{version}-%{release}
Provides:      golang(%{import_path}/mongodump) = %{version}-%{release}
Provides:      golang(%{import_path}/mongoexport) = %{version}-%{release}
Provides:      golang(%{import_path}/mongofiles) = %{version}-%{release}
Provides:      golang(%{import_path}/mongoimport) = %{version}-%{release}
Provides:      golang(%{import_path}/mongoimport/csv) = %{version}-%{release}
Provides:      golang(%{import_path}/mongooplog) = %{version}-%{release}
Provides:      golang(%{import_path}/mongorestore) = %{version}-%{release}
Provides:      golang(%{import_path}/mongostat) = %{version}-%{release}
Provides:      golang(%{import_path}/mongotop) = %{version}-%{release}

%description devel
This package contains library source intended for
building other packages which use %{project}/%{repo}.
%endif


%prep
%setup -q -n %{repo}-%{commit}
%if ! 0%{?with_bundled}
%patch0 -p1
%endif

%build
# Make link for etcd itself
mkdir -p ./_build/src/github.com/mongodb
ln -s $(pwd) ./_build/src/github.com/mongodb/mongo-tools

%if 0%{?with_debug}
function gobuild { go build -a -ldflags "-B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \n')" -v -x "$@"; }
%else
function gobuild { go build -a "$@"; }
%endif

%if 0%{?with_bundled}
export GOPATH=$(pwd)/vendor:$(pwd)/_build:%{gopath}
%else
export GOPATH=$(pwd)/_build:%{gopath}
%endif

mkdir bin
binaries=(bsondump mongostat mongofiles mongoexport mongoimport mongorestore mongodump mongotop mongooplog)
for bin in "${binaries[@]}"; do
  gobuild -o bin/${bin} -tags ssl ${bin}/main/${bin}.go
done

# Copy Apache license
cp %{SOURCE10} $(basename %{SOURCE10})

%install
# main package binary
install -d -p %{buildroot}%{_bindir}
install -p -m 0755 bin/* %{buildroot}%{_bindir}

%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/

# copy directories
for file in ./* ; do
    if [ -d $file ]; then
        cp -rpav $file %{buildroot}%{gopath}/src/%{import_path}/
    fi
done

rm -rf %{buildroot}%{gopath}/src/%{import_path}/bin
rm -rf %{buildroot}%{gopath}/src/%{import_path}/vendor
rm -rf %{buildroot}%{gopath}/src/%{import_path}/test
rm -rf %{buildroot}%{gopath}/src/%{import_path}/_build
rm -rf %{buildroot}%{gopath}/src/%{import_path}/mongorestore/testdata
rm -rf %{buildroot}%{gopath}/src/%{import_path}/common/db/openssl/testdata
%endif

install -d -m 755            %{buildroot}%{_mandir}/man1
install -p -m 644 %{SOURCE1} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE2} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE3} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE4} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE5} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE6} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE7} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE8} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE9} %{buildroot}%{_mandir}/man1/


%check
%if 0%{?with_bundled}
export GOPATH=$(pwd)/vendor:$(pwd)/_build:%{gopath}
%else
export GOPATH=$(pwd)/_build:%{gopath}
%endif
go test %{import_path}/common/bsonutil
go test %{import_path}/common/db
go test %{import_path}/common/intents
# redeclaration of C
#go test {import_path}/common/json
# import cycle not allowed in test
#go test {import_path}/common/log
go test %{import_path}/common/progress
go test %{import_path}/common/text
go test %{import_path}/common/util
go test %{import_path}/mongodump
go test %{import_path}/mongoexport
go test %{import_path}/mongofiles
#go test {import_path}/mongoimport
go test %{import_path}/mongooplog
go test %{import_path}/mongorestore
go test %{import_path}/mongostat


%files
%if 0%{?fedora}
%license LICENSE.md APACHE-2.0.txt
%else
%doc LICENSE.md APACHE-2.0.txt
%endif
%doc Godeps README.md CONTRIBUTING.md THIRD-PARTY-NOTICES
%{_bindir}/*
%{_mandir}/man1/*

%if 0%{?with_devel}
%files devel
%if 0%{?fedora}
%license LICENSE.md
%else
%doc LICENSE.md
%endif
%doc Godeps README.md CONTRIBUTING.md THIRD-PARTY-NOTICES
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%{gopath}/src/%{import_path}
%endif


%changelog
* Mon Jun 22 2015 Marek Skalicky <mskalick@redhat.com> - 3.0.4-1
- Repacked by using gofed tool (thanks to jchaloup@redhat.com)

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon May 11 2015 Marek Skalicky <mskalick@redhat.com> - 3.0.3-1
- Upgrade to version 3.0.3
- Add Apache license

* Mon May 4 2015 Marek Skalicky <mskalick@redhat.com> - 3.0.2-1
- Initial packaging
